//    gtkThemeMod - a gtk rc style editor.
//    Copyright (C) 2007-2008  Jonathan Westbrock <dulljon@yahoo.com>
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using Gtk;
using Gdk;

public partial class MainWindow: Gtk.Window
{	
	string[] strBase = new string [5];
	string[] strFg = new string [5];
	string[] strBg = new string [5];
	string[] strText = new string [5];
	public MainWindow (): base (Gtk.WindowType.Toplevel)
	{
		Build ();
		//Set some default colors.
		for(int q = 0; q < strBase.GetLength(0); q++)
		{
			strBase[q] = "#FFFFFF";
			strFg[q] = "#000000";
			strBg[q] = "#FFFFFF";
			strText[q] = "#000000";
		}
		//Enumerate available styles into a combobox.
		foreach(string strDir in System.IO.Directory.GetDirectories("/home/" + System.Environment.UserName.ToString() + "/.themes"))
		{
			cboLoad.AppendText(strDir.Substring(strDir.LastIndexOf("/")+1));
		}
		/*foreach(string strModule in System.IO.Directory.GetFiles(Gtk.Rc.ModuleDir))
		{
			cboEngine.AppendText(strModule.Remove(0,Gtk.Rc.ModuleDir.Length));
		}*/
		//Set the states for the preview widgets.
		btnActive.State = Gtk.StateType.Active;
		btnInsensitive.State = Gtk.StateType.Insensitive;
		btnNormal.State = Gtk.StateType.Normal;
		btnPrelight.State = Gtk.StateType.Prelight;
		btnSelected.State = Gtk.StateType.Selected;
		
		chkActive.State = Gtk.StateType.Active;
		chkInsensitive.State = Gtk.StateType.Insensitive;
		chkNormal.State = Gtk.StateType.Normal;
		chkPrelight.State = Gtk.StateType.Prelight;
		chkSelected.State = Gtk.StateType.Selected;
		
		entActive.State = Gtk.StateType.Active;
		entInsensitive.State = Gtk.StateType.Insensitive;
		entNormal.State = Gtk.StateType.Normal;
		entPrelight.State = Gtk.StateType.Prelight;
		entSelected.State = Gtk.StateType.Selected;
		
		sclActive.State = Gtk.StateType.Active;
		sclInsensitive.State = Gtk.StateType.Insensitive;
		sclNormal.State = Gtk.StateType.Normal;
		sclPrelight.State = Gtk.StateType.Prelight;
		sclSelected.State = Gtk.StateType.Selected;
		
		rdoActive.State = Gtk.StateType.Active;
		rdoInsensitive.State = Gtk.StateType.Insensitive;
		rdoNormal.State = Gtk.StateType.Normal;
		rdoPrelight.State = Gtk.StateType.Prelight;
		rdoSelected.State = Gtk.StateType.Selected;
		
		lblActive.State = Gtk.StateType.Active;
		lblInsensitive.State = Gtk.StateType.Insensitive;
		lblNormal.State = Gtk.StateType.Normal;
		lblPrelight.State = Gtk.StateType.Prelight;
		lblSelected.State = Gtk.StateType.Selected;
	}
	
	protected void OnDeleteEvent (object sender, DeleteEventArgs a)
	{
		Application.Quit ();
		a.RetVal = true;
	}

	protected virtual void OnColorselection1ColorChanged (object sender, System.EventArgs e)
	{
		//Set the widget colors in the preview pane.
		SetColors(vbxButtons,cbeState.ActiveText,cbeStyle.ActiveText,cslSelector.CurrentColor);
		SetColors(vbxChecks,cbeState.ActiveText,cbeStyle.ActiveText,cslSelector.CurrentColor);
		SetColors(vbxRadios,cbeState.ActiveText,cbeStyle.ActiveText,cslSelector.CurrentColor);
		SetColors(vbxLabels,cbeState.ActiveText,cbeStyle.ActiveText,cslSelector.CurrentColor);
		SetColors(vbxEntries,cbeState.ActiveText,cbeStyle.ActiveText,cslSelector.CurrentColor);
		SetColors(vbxRanges,cbeState.ActiveText,cbeStyle.ActiveText,cslSelector.CurrentColor);
	}
	//Preserve preview widget states.
	protected virtual void OnBtnPrelightStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(btnPrelight.State != Gtk.StateType.Prelight)
		{
			btnPrelight.State = Gtk.StateType.Prelight;
		}
	}

	protected virtual void OnBtnActiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(btnActive.State != Gtk.StateType.Active)
		{
			btnActive.State = Gtk.StateType.Active;
		}
	}

	protected virtual void OnBtnInsensitiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(btnInsensitive.State != Gtk.StateType.Insensitive)
		{
			btnInsensitive.State = Gtk.StateType.Insensitive;
		}
	}

	protected virtual void OnBtnNormalStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(btnNormal.State != Gtk.StateType.Normal)
		{
			btnNormal.State = Gtk.StateType.Normal;
		}
	}

	protected virtual void OnBtnSelectedStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(btnSelected.State != Gtk.StateType.Selected)
		{
			btnSelected.State = Gtk.StateType.Selected;
		}
	}
	protected virtual void OnChkActiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(!chkActive.Active)
		{
			chkActive.Active = true;
		}
	}

	protected virtual void OnChkInsensitiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(chkInsensitive.State != Gtk.StateType.Insensitive)
		{
			chkInsensitive.State = Gtk.StateType.Insensitive;
		}
	}

	protected virtual void OnChkNormalStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(chkNormal.State != Gtk.StateType.Normal)
		{
			chkNormal.State = Gtk.StateType.Normal;
		}
	}

	protected virtual void OnChkPrelightStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(chkPrelight.State != Gtk.StateType.Prelight)
		{
			chkPrelight.State = Gtk.StateType.Prelight;
		}
	}

	protected virtual void OnChkSelectedStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(chkSelected.State != Gtk.StateType.Selected)
		{
			chkSelected.State = Gtk.StateType.Selected;
		}
	}

	protected virtual void OnEntActiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(entActive.State != Gtk.StateType.Active)
		{
			entActive.State = Gtk.StateType.Active;
			
		}
	}

	protected virtual void OnEntInsensitiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(entInsensitive.State != Gtk.StateType.Insensitive)
		{
			entInsensitive.State = Gtk.StateType.Insensitive;
		}
	}

	protected virtual void OnEntNormalStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(entNormal.State != Gtk.StateType.Normal)
		{
			entNormal.State = Gtk.StateType.Normal;
		}
	}

	protected virtual void OnEntPrelightStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(entPrelight.State != Gtk.StateType.Prelight)
		{
			entPrelight.State = Gtk.StateType.Prelight;
		}
	}

	protected virtual void OnEntSelectedStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(entSelected.State != Gtk.StateType.Selected)
		{
			entSelected.State = Gtk.StateType.Selected;
		}
	}

	protected virtual void OnSclActiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(sclActive.State != Gtk.StateType.Active)
		{
			sclActive.State = Gtk.StateType.Active;
		}
	}

	protected virtual void OnSclInsensitiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(sclInsensitive.State != Gtk.StateType.Insensitive)
		{
			sclInsensitive.State = Gtk.StateType.Insensitive;
		}
	}

	protected virtual void OnSclNormalStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(sclNormal.State != Gtk.StateType.Normal)
		{
			sclNormal.State = Gtk.StateType.Normal;
		}
	}

	protected virtual void OnSclPrelightStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(sclPrelight.State != Gtk.StateType.Prelight)
		{
			sclPrelight.State = Gtk.StateType.Prelight;
		}
	}

	protected virtual void OnSclSelectedStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(sclSelected.State != Gtk.StateType.Selected)
		{
			sclSelected.State = Gtk.StateType.Selected;
		}
	}

	protected virtual void OnRdoActiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(rdoActive.State != Gtk.StateType.Active)
		{
			rdoActive.State = Gtk.StateType.Active;
		}
	}

	protected virtual void OnRdoInsensitiveStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(rdoInsensitive.State != Gtk.StateType.Insensitive)
		{
			rdoInsensitive.State = Gtk.StateType.Insensitive;
		}
	}

	protected virtual void OnRdoNormalStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(rdoNormal.State != Gtk.StateType.Normal)
		{
			rdoNormal.State = Gtk.StateType.Normal;
		}
	}

	protected virtual void OnRdoPrelightStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(rdoPrelight.State != Gtk.StateType.Prelight)
		{
			rdoPrelight.State = Gtk.StateType.Prelight;
		}
	}

	protected virtual void OnRdoSelectedStateChanged (object o, Gtk.StateChangedArgs args)
	{
		if(rdoSelected.State != Gtk.StateType.Selected)
		{
			rdoSelected.State = Gtk.StateType.Selected;
		}
	}
	
	
	//Set the color properties from widgets belonging to the container passed.
	void SetColors (Gtk.Container cntContainer, string strState, string strProperty, Gdk.Color clrColor)
	{
		foreach(Gtk.Widget widget in cntContainer.AllChildren)
		{
			widget.ResetRcStyles();
			switch(strState)
			{
			case "Active":
				switch(strProperty)
				{
			case "Base":
				widget.ModifyBase(Gtk.StateType.Active, clrColor);
				strBase[0] = HexFormat(clrColor);
				
				break;
				
			case "Foreground":
				widget.ModifyFg(Gtk.StateType.Active, clrColor);
				strFg[0] = HexFormat(clrColor);
				break;
			case "Background":
				widget.ModifyBg(Gtk.StateType.Active, clrColor);
				strBg[0] = HexFormat(clrColor);
				break;
			case "Text":
				widget.ModifyText(Gtk.StateType.Active, clrColor);
				strText[0] = HexFormat(clrColor);
				break;
			}
			break;
			case "Insensitive":
				switch(strProperty)
				{
			case "Base":
				widget.ModifyBase(Gtk.StateType.Insensitive, clrColor);
				strBase[1] = HexFormat(clrColor);
				break;
			case "Foreground":
				widget.ModifyFg(Gtk.StateType.Insensitive, clrColor);
				strFg[1] = HexFormat(clrColor);
				break;
			case "Background":
				widget.ModifyBg(Gtk.StateType.Insensitive, clrColor);
				strBg[1] = HexFormat(clrColor);
				break;
			case "Text":
				widget.ModifyText(Gtk.StateType.Insensitive, clrColor);
				strText[1] = HexFormat(clrColor);
				break;
			}
			break;
			case "Normal":
				switch(strProperty)
				{
			case "Base":
				widget.ModifyBase(Gtk.StateType.Normal, clrColor);
				strBase[2] = HexFormat(clrColor);
				break;
			case "Foreground":
				widget.ModifyFg(Gtk.StateType.Normal, clrColor);
				strFg[2] = HexFormat(clrColor);
				break;
			case "Background":
				widget.ModifyBg(Gtk.StateType.Normal, clrColor);
				strBg[2] = HexFormat(clrColor);
				expPreview.ModifyBg(Gtk.StateType.Normal, clrColor);
				break;
			case "Text":
				widget.ModifyText(Gtk.StateType.Normal, clrColor);
				strText[2] = HexFormat(clrColor);
				break;
			}
			break;
			case "Prelight":
				switch(strProperty)
				{
			case "Base":
				widget.ModifyBase(Gtk.StateType.Prelight, clrColor);
				strBase[3] = HexFormat(clrColor);
				break;
			case "Foreground":
				widget.ModifyFg(Gtk.StateType.Prelight, clrColor);
				strFg[3] = HexFormat(clrColor);
				break;
			case "Background":
				widget.ModifyBg(Gtk.StateType.Prelight, clrColor);
				strBg[3] = HexFormat(clrColor);
				break;
			case "Text":
				widget.ModifyText(Gtk.StateType.Prelight, clrColor);
				strText[3] = HexFormat(clrColor);
				break;
			}
			break;
			case "Selected":
				switch(strProperty)
				{
			case "Base":
				widget.ModifyBase(Gtk.StateType.Selected, clrColor);
				strBase[4] = HexFormat(clrColor);
				break;
			case "Foreground":
				widget.ModifyFg(Gtk.StateType.Selected, clrColor);
				strFg[4] = HexFormat(clrColor);
				break;
			case "Background":
				widget.ModifyBg(Gtk.StateType.Selected, clrColor);
				strBg[4] = HexFormat(clrColor);
				break;
			case "Text":
				widget.ModifyText(Gtk.StateType.Selected, clrColor);
				strText[4] = HexFormat(clrColor);
				break;
			}
			break;
			
			}
		}
		
	}
	
	//Save routine.
	
	protected virtual void OnBtnSaveClicked (object sender, System.EventArgs e)
	{
		string strRc;
		strRc = "/home/" + System.Environment.UserName.ToString() + "/.themes/" + entRcpath.Text;
		if (!System.IO.Directory.Exists(strRc))
		{
			System.IO.Directory.CreateDirectory(strRc).CreateSubdirectory("gtk-2.0");
		}
		pgbStatus.Text = "Saving " + entRcpath.Text + "...";
		pgbStatus.Pulse();
		System.IO.StreamWriter stwRcout = new System.IO.StreamWriter(strRc + "/gtk-2.0/" + "gtkrc",false);
		stwRcout.WriteLine("\t#Generated by gtkThemeMod. Love it or don't.");
		stwRcout.WriteLine("\tstyle \"theme-default\"");
		stwRcout.WriteLine("\t{");
		stwRcout.WriteLine("\t\tbase[ACTIVE]\t\t= \"" + strBase[0] + "\"");
		stwRcout.WriteLine("\t\tbase[INSENSITIVE]\t= \"" + strBase[1] + "\"");
        stwRcout.WriteLine("\t\tbase[NORMAL]\t\t= \"" + strBase[2] + "\"");
        stwRcout.WriteLine("\t\tbase[PRELIGHT]\t\t= \"" + strBase[3] + "\"");
        stwRcout.WriteLine("\t\tbase[SELECTED]\t\t= \"" + strBase[4] + "\"");
        stwRcout.WriteLine("");
		stwRcout.WriteLine("\t\tfg[ACTIVE]\t\t= \"" + strFg[0] + "\"");
        stwRcout.WriteLine("\t\tfg[INSENSITIVE]\t\t= \"" + strFg[1] + "\"");
        stwRcout.WriteLine("\t\tfg[NORMAL]\t\t= \"" + strFg[2] + "\"");
        stwRcout.WriteLine("\t\tfg[PRELIGHT]\t\t= \"" + strFg[3] + "\"");
        stwRcout.WriteLine("\t\tfg[SELECTED]\t\t= \"" + strFg[4] + "\"");
		stwRcout.WriteLine("");
        stwRcout.WriteLine("\t\tbg[ACTIVE]\t\t= \"" + strBg[0] + "\"");
        stwRcout.WriteLine("\t\tbg[INSENSITIVE]\t\t= \"" + strBg[1] + "\"");
        pgbStatus.Pulse();
		stwRcout.WriteLine("\t\tbg[NORMAL]\t\t= \"" + strBg[2] + "\"");
        stwRcout.WriteLine("\t\tbg[PRELIGHT]\t\t= \"" + strBg[3] + "\"");
        stwRcout.WriteLine("\t\tbg[SELECTED]\t\t= \"" + strBg[4] + "\"");
		stwRcout.WriteLine("");
		stwRcout.WriteLine("\t\ttext[ACTIVE]\t\t= \"" + strText[0] + "\"");
        stwRcout.WriteLine("\t\ttext[INSENSITIVE]\t= \"" + strText[1] + "\"");
        stwRcout.WriteLine("\t\ttext[NORMAL]\t\t= \"" + strText[2] + "\"");
        stwRcout.WriteLine("\t\ttext[PRELIGHT]\t\t= \"" + strText[3] + "\"");
        stwRcout.WriteLine("\t\ttext[SELECTED]\t\t= \"" + strText[4] + "\"");
		stwRcout.WriteLine("");
		if (chkUseengine.Active)
		{
			stwRcout.WriteLine("\t\tengine \"" + cboEngine.ActiveText.ToLower() +  "\" ");
			stwRcout.WriteLine("\t\t{");
			stwRcout.WriteLine("\t\t\tmenuitemstyle \t\t= " + cboMenuitemstyle.Active + "");
			stwRcout.WriteLine("\t\t\tglazestyle \t\t= " + cboGlazestyle.Active + "");
			stwRcout.WriteLine("\t\t\tscrollbar_color \t= \"" + HexFormat(cbnScrollbarcolor.Color) + "\"");
			stwRcout.WriteLine("\t\t\tcontrast \t\t= " + (sclContrast.Value/10).ToString("F") + "");
			pgbStatus.Pulse();
			stwRcout.WriteLine("\t\t\tmenubarstyle \t\t= " + cboMenubarstyle.Active + "");
			stwRcout.WriteLine("\t\t\tmenubaritemstyle \t= " + cboMenubaritemstyle.Active + "");
			stwRcout.WriteLine("\t\t\tlistviewheaderstyle \t= " + cboListviewheaderstyle.Active + "");
			stwRcout.WriteLine("\t\t\troundness \t\t= " + sclRoundness.Value + "");
			stwRcout.WriteLine("\t\t\tanimation \t\t= " + chkEnableanimation.Active.ToString().ToUpper() + "");
			stwRcout.WriteLine("\t\t\tgradients \t\t= " + chkEnablegradients.Active.ToString().ToUpper() + "");
			stwRcout.WriteLine("\t\t}");
		}
		stwRcout.WriteLine("\t}");
		stwRcout.WriteLine("");
		stwRcout.WriteLine("\tclass \"GtkWidget\"\t\t\t\tstyle \"theme-default\"");
		
		pgbStatus.Pulse();
		stwRcout.Close();
		pgbStatus.Fraction = 0;
		pgbStatus.Text = "";
	}

	static string HexFormat (Gdk.Color clrColor)
	{
		string strHex;
		ushort[] intColors = { clrColor.Red, clrColor.Green, clrColor.Blue };
		char[] chrFormat = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
		strHex = "#";
		foreach (ushort intColor in intColors) 
		{
			byte bytRound = (byte) (intColor >> 8);
			strHex += (chrFormat[(bytRound & 0xf0) >> 4]);
			strHex += (chrFormat[bytRound & 0x0f]);
		}

		return strHex.ToString ();
	}

	protected virtual void OnBtnLoadClicked (object sender, System.EventArgs e)
	{
		//Open the style and read everything to a string.
		System.IO.StreamReader srdSettings = new System.IO.StreamReader("/home/" + System.Environment.UserName.ToString() + "/.themes/" + cboLoad.ActiveText + "/gtk-2.0/gtkrc");
		string strSettings = srdSettings.ReadToEnd();
		srdSettings.Close();
		//Parse for color options
		string strHolder = strSettings.Remove(0,strSettings.IndexOf("base[ACTIVE]") - 1);
		strBase[0] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color clrHolder = new Color(); Color.Parse(strBase[0],ref clrHolder);
		SetColors(vbxButtons,"Active","Base",clrHolder);
		SetColors(vbxChecks,"Active","Base",clrHolder);
		SetColors(vbxRadios,"Active","Base",clrHolder);
		SetColors(vbxLabels,"Active","Base",clrHolder);
		SetColors(vbxEntries,"Active","Base",clrHolder);
		SetColors(vbxRanges,"Active","Base",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("base[INSENSITIVE]") - 1);
		strBase[1] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBase[1],ref clrHolder);
		SetColors(vbxButtons,"Insensitive","Base",clrHolder);
		SetColors(vbxChecks,"Insensitive","Base",clrHolder);
		SetColors(vbxRadios,"Insensitive","Base",clrHolder);
		SetColors(vbxLabels,"Insensitive","Base",clrHolder);
		SetColors(vbxEntries,"Insensitive","Base",clrHolder);
		SetColors(vbxRanges,"Insensitive","Base",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("base[NORMAL]") - 1);
		strBase[2] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBase[2],ref clrHolder);
		SetColors(vbxButtons,"Normal","Base",clrHolder);
		SetColors(vbxChecks,"Normal","Base",clrHolder);
		SetColors(vbxRadios,"Normal","Base",clrHolder);
		SetColors(vbxLabels,"Normal","Base",clrHolder);
		SetColors(vbxEntries,"Normal","Base",clrHolder);
		SetColors(vbxRanges,"Normal","Base",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("base[PRELIGHT]") - 1);
		strBase[3] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBase[3],ref clrHolder);
		SetColors(vbxButtons,"Prelight","Base",clrHolder);
		SetColors(vbxChecks,"Prelight","Base",clrHolder);
		SetColors(vbxRadios,"Prelight","Base",clrHolder);
		SetColors(vbxLabels,"Prelight","Base",clrHolder);
		SetColors(vbxEntries,"Prelight","Base",clrHolder);
		SetColors(vbxRanges,"Prelight","Base",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("base[SELECTED]") - 1);
		strBase[4] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBase[4],ref clrHolder);
		SetColors(vbxButtons,"Selected","Base",clrHolder);
		SetColors(vbxChecks,"Selected","Base",clrHolder);
		SetColors(vbxRadios,"Selected","Base",clrHolder);
		SetColors(vbxLabels,"Selected","Base",clrHolder);
		SetColors(vbxEntries,"Selected","Base",clrHolder);
		SetColors(vbxRanges,"Selected","Base",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("fg[ACTIVE]") - 1);
		strFg[0] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strFg[0],ref clrHolder);
		SetColors(vbxButtons,"Active","Foreground",clrHolder);
		SetColors(vbxChecks,"Active","Foreground",clrHolder);
		SetColors(vbxRadios,"Active","Foreground",clrHolder);
		SetColors(vbxLabels,"Active","Foreground",clrHolder);
		SetColors(vbxEntries,"Active","Foreground",clrHolder);
		SetColors(vbxRanges,"Active","Foreground",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("fg[INSENSITIVE]") - 1);
		strFg[1] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strFg[1],ref clrHolder);
		SetColors(vbxButtons,"Insensitive","Foreground",clrHolder);
		SetColors(vbxChecks,"Insensitive","Foreground",clrHolder);
		SetColors(vbxRadios,"Insensitive","Foreground",clrHolder);
		SetColors(vbxLabels,"Insensitive","Foreground",clrHolder);
		SetColors(vbxEntries,"Insensitive","Foreground",clrHolder);
		SetColors(vbxRanges,"Insensitive","Foreground",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("fg[NORMAL]") - 1);
		strFg[2] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strFg[2],ref clrHolder);
		SetColors(vbxButtons,"Normal","Foreground",clrHolder);
		SetColors(vbxChecks,"Normal","Foreground",clrHolder);
		SetColors(vbxRadios,"Normal","Foreground",clrHolder);
		SetColors(vbxLabels,"Normal","Foreground",clrHolder);
		SetColors(vbxEntries,"Normal","Foreground",clrHolder);
		SetColors(vbxRanges,"Normal","Foreground",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("fg[PRELIGHT]") - 1);
		strFg[3] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strFg[3],ref clrHolder);
		SetColors(vbxButtons,"Prelight","Foreground",clrHolder);
		SetColors(vbxChecks,"Prelight","Foreground",clrHolder);
		SetColors(vbxRadios,"Prelight","Foreground",clrHolder);
		SetColors(vbxLabels,"Prelight","Foreground",clrHolder);
		SetColors(vbxEntries,"Prelight","Foreground",clrHolder);
		SetColors(vbxRanges,"Prelight","Foreground",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("fg[SELECTED]") - 1);
		strFg[4] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strFg[4],ref clrHolder);
		SetColors(vbxButtons,"Selected","Foreground",clrHolder);
		SetColors(vbxChecks,"Selected","Foreground",clrHolder);
		SetColors(vbxRadios,"Selected","Foreground",clrHolder);
		SetColors(vbxLabels,"Selected","Foreground",clrHolder);
		SetColors(vbxEntries,"Selected","Foreground",clrHolder);
		SetColors(vbxRanges,"Selected","Foreground",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("bg[ACTIVE]") - 1);
		strBg[0] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBg[0],ref clrHolder);
		SetColors(vbxButtons,"Active","Background",clrHolder);
		SetColors(vbxChecks,"Active","Background",clrHolder);
		SetColors(vbxRadios,"Active","Background",clrHolder);
		SetColors(vbxLabels,"Active","Background",clrHolder);
		SetColors(vbxEntries,"Active","Background",clrHolder);
		SetColors(vbxRanges,"Active","Background",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("bg[INSENSITIVE]") - 1);
		strBg[1] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBg[1],ref clrHolder);
		SetColors(vbxButtons,"Insensitive","Background",clrHolder);
		SetColors(vbxChecks,"Insensitive","Background",clrHolder);
		SetColors(vbxRadios,"Insensitive","Background",clrHolder);
		SetColors(vbxLabels,"Insensitive","Background",clrHolder);
		SetColors(vbxEntries,"Insensitive","Background",clrHolder);
		SetColors(vbxRanges,"Insensitive","Background",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("bg[NORMAL]") - 1);
		strBg[2] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBg[2],ref clrHolder);
		SetColors(vbxButtons,"Normal","Background",clrHolder);
		SetColors(vbxChecks,"Normal","Background",clrHolder);
		SetColors(vbxRadios,"Normal","Background",clrHolder);
		SetColors(vbxLabels,"Normal","Background",clrHolder);
		SetColors(vbxEntries,"Normal","Background",clrHolder);
		SetColors(vbxRanges,"Normal","Background",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("bg[PRELIGHT]") - 1);
		strBg[3] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBg[3],ref clrHolder);
		SetColors(vbxButtons,"Prelight","Background",clrHolder);
		SetColors(vbxChecks,"Prelight","Background",clrHolder);
		SetColors(vbxRadios,"Prelight","Background",clrHolder);
		SetColors(vbxLabels,"Prelight","Background",clrHolder);
		SetColors(vbxEntries,"Prelight","Background",clrHolder);
		SetColors(vbxRanges,"Prelight","Background",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("bg[SELECTED]") - 1);
		strBg[4] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strBg[4],ref clrHolder);
		SetColors(vbxButtons,"Selected","Background",clrHolder);
		SetColors(vbxChecks,"Selected","Background",clrHolder);
		SetColors(vbxRadios,"Selected","Background",clrHolder);
		SetColors(vbxLabels,"Selected","Background",clrHolder);
		SetColors(vbxEntries,"Selected","Background",clrHolder);
		SetColors(vbxRanges,"Selected","Background",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("text[ACTIVE]") - 1);
		strText[0] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strText[0],ref clrHolder);
		SetColors(vbxButtons,"Active","Text",clrHolder);
		SetColors(vbxChecks,"Active","Text",clrHolder);
		SetColors(vbxRadios,"Active","Text",clrHolder);
		SetColors(vbxLabels,"Active","Text",clrHolder);
		SetColors(vbxEntries,"Active","Text",clrHolder);
		SetColors(vbxRanges,"Active","Text",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("text[INSENSITIVE]") - 1);
		strText[1] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strText[1],ref clrHolder);
		SetColors(vbxButtons,"Insensitive","Text",clrHolder);
		SetColors(vbxChecks,"Insensitive","Text",clrHolder);
		SetColors(vbxRadios,"Insensitive","Text",clrHolder);
		SetColors(vbxLabels,"Insensitive","Text",clrHolder);
		SetColors(vbxEntries,"Insensitive","Text",clrHolder);
		SetColors(vbxRanges,"Insensitive","Text",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("text[NORMAL]") - 1);
		strText[2] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strText[2],ref clrHolder);
		SetColors(vbxButtons,"Normal","Text",clrHolder);
		SetColors(vbxChecks,"Normal","Text",clrHolder);
		SetColors(vbxRadios,"Normal","Text",clrHolder);
		SetColors(vbxLabels,"Normal","Text",clrHolder);
		SetColors(vbxEntries,"Normal","Text",clrHolder);
		SetColors(vbxRanges,"Normal","Text",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("text[PRELIGHT]") - 1);
		strText[3] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strText[3],ref clrHolder);
		SetColors(vbxButtons,"Prelight","Text",clrHolder);
		SetColors(vbxChecks,"Prelight","Text",clrHolder);
		SetColors(vbxRadios,"Prelight","Text",clrHolder);
		SetColors(vbxLabels,"Prelight","Text",clrHolder);
		SetColors(vbxEntries,"Prelight","Text",clrHolder);
		SetColors(vbxRanges,"Prelight","Text",clrHolder);
		
		strHolder = strSettings.Remove(0,strSettings.IndexOf("text[SELECTED]") - 1);
		strText[4] = strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7);
		Color.Parse(strText[4],ref clrHolder);
		SetColors(vbxButtons,"Selected","Text",clrHolder);
		SetColors(vbxChecks,"Selected","Text",clrHolder);
		SetColors(vbxRadios,"Selected","Text",clrHolder);
		SetColors(vbxLabels,"Selected","Text",clrHolder);
		SetColors(vbxEntries,"Selected","Text",clrHolder);
		SetColors(vbxRanges,"Selected","Text",clrHolder);
		
		//Parse for Murrine options

		if(strSettings.IndexOf("engine") > 0)
		{
			strHolder = strSettings.Remove(0,strSettings.IndexOf("engine") - 1);
			chkUseengine.Active = true;
			if(strSettings.IndexOf("menuitemstyle") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("menuitemstyle"));
				cboMenubaritemstyle.Active = int.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,1));
			}
			if(strSettings.IndexOf("glazestyle") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("glazestyle"));
				cboGlazestyle.Active = int.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,1));
			}
			if(strSettings.IndexOf("scrollbar_color") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("scrollbar_color") - 1);
				Color.Parse(strHolder.Remove(0,strHolder.IndexOf("#")).Substring(0,7),ref clrHolder);
				cbnScrollbarcolor.Color = clrHolder;
			}
			if(strSettings.IndexOf("contrast") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("contrast"));
				sclContrast.Value = (double.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,4))*10);
			}
			if(strSettings.IndexOf("menubarstyle") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("menubarstyle"));
				cboMenubarstyle.Active = int.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,1));
			}
			if(strSettings.IndexOf("menubaritemstyle") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("menubaritemstyle"));
				cboMenubaritemstyle.Active = int.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,1));
			}
			if(strSettings.IndexOf("listviewheaderstyle") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("listviewheaderstyle"));
				cboListviewheaderstyle.Active = int.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,1));
			}
			if(strSettings.IndexOf("roundness") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("roundness"));
				sclRoundness.Value = int.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,2));
			}
			if(strSettings.IndexOf("animation") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("animation"));
				chkEnableanimation.Active = bool.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,4));
			}
			if(strSettings.IndexOf("gradients") > -1)
			{
				strHolder = strSettings.Remove(0,strSettings.IndexOf("gradients"));
				chkEnablegradients.Active = bool.Parse(strHolder.Remove(0,strHolder.IndexOf("= ")+1).Substring(1,5));
			}
		}
		else
		{
			chkUseengine.Active = false;
		}
	}
}